Index: /palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- /palm/trunk/SOURCE/salsa_mod.f90	(revision 3863)
+++ /palm/trunk/SOURCE/salsa_mod.f90	(revision 3864)
@@ -8355,322 +8626,349 @@
 !> Sets the gaseous fluxes
 !------------------------------------------------------------------------------!
- SUBROUTINE set_gas_flux( surface, ncat_emission, unit )
- 
-    USE arrays_3d,                                                             &
-        ONLY: dzw, hyp, pt, rho_air_zw
-        
-    USE grid_variables,                                                        &
-        ONLY:  dx, dy
- 
-    USE surface_mod,                                                           &
-        ONLY:  surf_type
-    
+ SUBROUTINE salsa_gas_emission_setup( init )
+
+    USE control_parameters,                                                                        &
+        ONLY:  time_since_reference_point
+
+    USE date_and_time_mod,                                                                         &
+        ONLY:  day_of_month, hour_of_day, index_dd, index_hh, index_mm, month_of_year,             &
+               time_default_indices, time_utc_init
+
+    USE netcdf_data_input_mod,                                                                     &
+        ONLY:  check_existence, chem_emis_att_type, chem_emis_val_type, get_attribute,             &
+               get_variable, inquire_num_variables, inquire_variable_names,                        &
+               netcdf_data_input_get_dimension_length, open_read_file
+
+    USE surface_mod,                                                                               &
+        ONLY:  surf_def_h, surf_lsm_h, surf_usm_h
+
     IMPLICIT NONE
-    
-    CHARACTER(LEN=*) ::  unit       !< flux unit in the input file  
-    INTEGER(iwp) ::  ncat_emission  !< number of emission categories
-    TYPE(surf_type), INTENT(inout) :: surface  !< respective surface type
-    INTEGER(iwp) ::  g   !< loop index
-    INTEGER(iwp) ::  i   !< loop index
-    INTEGER(iwp) ::  j   !< loop index
-    INTEGER(iwp) ::  k   !< loop index
-    INTEGER(iwp) ::  m   !< running index for surface elements
-    INTEGER(iwp) ::  n   !< running index for emission categories
-    REAL(wp), DIMENSION(ngast) ::  conversion_factor 
-    
-    conversion_factor = 1.0_wp
-    
-    DO  m = 1, surface%ns
-!
-!--    Get indices of respective grid point
-       i = surface%i(m)
-       j = surface%j(m)
-       k = surface%k(m)
-       
-       IF ( unit == '#/m2/s' )  THEN
-          conversion_factor = 1.0_wp
-       ELSEIF ( unit == 'g/m2/s' )  THEN
-          conversion_factor(1) = avo / ( amh2so4 * 1000.0_wp )
-          conversion_factor(2) = avo / ( amhno3 * 1000.0_wp )
-          conversion_factor(3) = avo / ( amnh3 * 1000.0_wp )
-          conversion_factor(4) = avo / ( amoc * 1000.0_wp )
-          conversion_factor(5) = avo / ( amoc * 1000.0_wp )
-       ELSEIF ( unit == 'ppm/m2/s' )  THEN
-          conversion_factor = for_ppm_to_nconc * hyp(k) / pt(k,j,i) * ( hyp(k) &
-                              / 100000.0_wp )**0.286_wp * dx * dy * dzw(k)
-       ELSEIF ( unit == 'mumol/m2/s' )  THEN
-          conversion_factor = 1.0E-6_wp * avo
+
+    CHARACTER(LEN=80) ::  daytype = 'workday'  !< default day type
+    CHARACTER(LEN=25) ::  in_name              !< name of a gas in the input file
+
+    CHARACTER(LEN=100), DIMENSION(:), ALLOCATABLE ::  var_names   !<  variable names in input data
+
+    INTEGER(iwp) ::  id_chem        !< NetCDF id of chemistry emission file
+    INTEGER(iwp) ::  ig             !< loop index
+    INTEGER(iwp) ::  in             !< running index for emission categories
+    INTEGER(iwp) ::  num_vars       !< number of variables
+
+    LOGICAL  ::  netcdf_extend = .FALSE.  !< NetCDF input file exists
+
+    LOGICAL, INTENT(in) ::  init          !< if .TRUE. --> initialisation call
+
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  time_factor  !< emission time factor
+
+    TYPE(chem_emis_att_type) ::  chem_emission_att  !< chemistry emission attributes
+    TYPE(chem_emis_val_type) ::  chem_emission      !< chemistry emission values
+
+!
+!-- Reset surface fluxes
+    surf_def_h(0)%gtsws = 0.0_wp
+    surf_lsm_h%gtsws = 0.0_wp
+    surf_usm_h%gtsws = 0.0_wp
+
+    IF ( init )  THEN
+#if defined( __netcdf )
+!
+!--    Check existence of PIDS_CHEM file
+       INQUIRE( FILE = 'PIDS_CHEM' // TRIM( coupling_char ), EXIST = netcdf_extend )
+       IF ( .NOT. netcdf_extend )  THEN
+          message_string = 'Input file PIDS_CHEM' //  TRIM( coupling_char ) // ' missing!'
+          CALL message( 'salsa_gas_emission_setup', 'PA0640', 1, 2, 0, 6, 0 )
+       ENDIF
+!
+!--    Open file in read-only mode
+       CALL open_read_file( 'PIDS_CHEM' // TRIM( coupling_char ), id_chem )
+!
+!--    Read the index and name of chemical components
+       CALL netcdf_data_input_get_dimension_length( id_chem, chem_emission_att%nspec,              &
+                                                    'nspecies' )
+       ALLOCATE( chem_emission_att%species_index(1:chem_emission_att%nspec) )
+       CALL get_variable( id_chem, 'emission_index', chem_emission_att%species_index )
+       CALL get_variable( id_chem, 'emission_name', chem_emission_att%species_name,                &
+                          chem_emission_att%nspec )
+!
+!--    Find the corresponding indices in the model
+       emission_index_chem = 0
+       DO  ig = 1, chem_emission_att%nspec
+          in_name = chem_emission_att%species_name(ig)
+          SELECT CASE ( TRIM( in_name ) )
+             CASE ( 'H2SO4', 'h2so4' )
+                emission_index_chem(1) = ig
+             CASE ( 'HNO3', 'hno3' )
+                emission_index_chem(2) = ig
+             CASE ( 'NH3', 'nh3' )
+                emission_index_chem(3) = ig
+             CASE ( 'OCNV', 'ocnv' )
+                emission_index_chem(4) = ig
+             CASE ( 'OCSV', 'ocsv' )
+                emission_index_chem(5) = ig
+          END SELECT
+       ENDDO
+       IF ( SUM( emission_index_chem ) == 0 )  THEN
+          CALL location_message( '    salsa_gas_emission_setup: no gas emissions', .TRUE. )
+       ENDIF
+!
+!--    Inquire the fill value
+       CALL get_attribute( id_chem, '_FillValue', aero_emission%fill, .FALSE., 'emission_values' )
+!
+!--    Inquire units of emissions
+       CALL get_attribute( id_chem, 'units', chem_emission_att%units, .FALSE., 'emission_values' )
+!
+!--    Inquire the level of detail (lod)
+       CALL get_attribute( id_chem, 'lod', lod_gas_emissions, .FALSE., 'emission_values' )
+!
+!--    Variable names
+       CALL inquire_num_variables( id_chem, num_vars )
+       ALLOCATE( var_names(1:num_vars) )
+       CALL inquire_variable_names( id_chem, var_names )
+!
+!--    Default mode: as total emissions per year
+       IF ( lod_gas_emissions == 1 )  THEN
+
+!
+!--       Get number of emission categories and allocate emission arrays
+          CALL netcdf_data_input_get_dimension_length( id_chem, chem_emission_att%ncat, 'ncat' )
+          ALLOCATE( chem_emission_att%cat_index(1:chem_emission_att%ncat),                         &
+                    time_factor(1:chem_emission_att%ncat) )
+!
+!--       Get emission category names and indices
+          CALL get_variable( id_chem, 'emission_category_name', chem_emission_att%cat_name,        &
+                             chem_emission_att%ncat)
+          CALL get_variable( id_chem, 'emission_category_index', chem_emission_att%cat_index )
+!
+!--       Emission time factors: Find check whether emission time factors are given for each hour
+!--       of year OR based on month, day and hour
+!
+!--       For each hour of year:
+          IF ( check_existence( var_names, 'nhoursyear' ) )  THEN
+             CALL netcdf_data_input_get_dimension_length( id_chem, chem_emission_att%nhoursyear,   &
+                                                          'nhoursyear' )
+             ALLOCATE( chem_emission_att%hourly_emis_time_factor(1:chem_emission_att%ncat,         &
+                                                                 1:chem_emission_att%nhoursyear) )
+             CALL get_variable( id_chem, 'emission_time_factors',                                  &
+                                chem_emission_att%hourly_emis_time_factor,                         &
+                                0, chem_emission_att%nhoursyear-1, 0, chem_emission_att%ncat-1 )
+!
+!--       Based on the month, day and hour:
+          ELSEIF ( check_existence( var_names, 'nmonthdayhour' ) )  THEN
+             CALL netcdf_data_input_get_dimension_length( id_chem, chem_emission_att%nmonthdayhour,&
+                                                          'nmonthdayhour' )
+             ALLOCATE( chem_emission_att%mdh_emis_time_factor(1:chem_emission_att%ncat,            &
+                                                              1:chem_emission_att%nmonthdayhour) )
+             CALL get_variable( id_chem, 'emission_time_factors',                                  &
+                                chem_emission_att%mdh_emis_time_factor,                            &
+                                0, chem_emission_att%nmonthdayhour-1, 0, chem_emission_att%ncat-1 )
+          ELSE
+             message_string = 'emission_time_factors should be given for each nhoursyear OR ' //   &
+                              'nmonthdayhour'
+             CALL message( 'salsa_gas_emission_setup','PA0641', 1, 2, 0, 6, 0 )
+          ENDIF
+!
+!--       Next emission update
+          next_gas_emission_update = MOD( time_utc_init, 3600.0_wp ) - 3600.0_wp
+!
+!--       Allocate and read surface emission data (in total PM) (NOTE that "preprocessed" input data
+!--       array is applied now here)
+          ALLOCATE( chem_emission%preproc_emission_data(nys:nyn,nxl:nxr, 1:chem_emission_att%nspec,&
+                                                        1:chem_emission_att%ncat) )
+          CALL get_variable( id_chem, 'emission_values', chem_emission%preproc_emission_data,      &
+                             0, chem_emission_att%ncat-1, 0, chem_emission_att%nspec-1,            &
+                             nxl, nxr, nys, nyn )
+!
+!--    Pre-processed mode:
+       ELSEIF ( lod_gas_emissions == 2 )  THEN
+!
+!--       Number of time steps in the emission data
+          CALL netcdf_data_input_get_dimension_length( id_chem, chem_emission_att%dt_emission,     &
+                                                       'time' )
+!
+!--       Allocate and read time
+          ALLOCATE( gas_emission_time(1:chem_emission_att%dt_emission) )
+          CALL get_variable( id_chem, 'time', gas_emission_time )
        ELSE
-          message_string = 'Unknown unit for gaseous emissions!'
-          CALL message( 'salsa_mod: set_gas_flux', 'SA0031', 1, 2, 0, 6, 0 )
-       ENDIF
-       
-       DO  n = 1, ncat_emission
-          DO  g = 1, ngast
-             IF ( salsa_gas(g)%source(n,j,i) < 0.0_wp )  THEN
-                salsa_gas(g)%source(n,j,i) = 0.0_wp
-                CYCLE
-             ENDIF
-             surface%gtsws(m,g) = surface%gtsws(m,g) +                         &
-                                  salsa_gas(g)%source(n,j,i) * rho_air_zw(k-1) &
-                                  * conversion_factor(g)
-          ENDDO
+          message_string = 'Unknown lod for emission_values.'
+          CALL message( 'salsa_gas_emission_setup','PA0642', 1, 2, 0, 6, 0 )
+       ENDIF  ! lod
+
+    ENDIF  ! init
+!
+!-- Define and set current emission values:
+
+    IF ( lod_gas_emissions == 1 )  THEN
+!
+!--    Emission time factors for each emission category at current time step
+       IF ( chem_emission_att%nhoursyear > chem_emission_att%nmonthdayhour )  THEN
+!
+!--       Get the index of the current hour
+          CALL time_default_indices( month_of_year, day_of_month, hour_of_day, index_hh )
+          time_factor = chem_emission_att%hourly_emis_time_factor(:,index_hh)
+
+       ELSEIF ( chem_emission_att%nhoursyear < chem_emission_att%nmonthdayhour )  THEN
+!
+!--       Get the index of current hour (index_hh) (TODO: Now "workday" is always assumed.
+!--       Needs to be calculated.)
+          CALL time_default_indices( daytype, month_of_year, day_of_month, hour_of_day,            &
+                                     index_mm, index_dd, index_hh )
+          time_factor = chem_emission_att%mdh_emis_time_factor(:,index_mm) *                       &
+                        chem_emission_att%mdh_emis_time_factor(:,index_dd) *                       &
+                        chem_emission_att%mdh_emis_time_factor(:,index_hh)
+       ENDIF
+!
+!--    Set gas emissions for each emission category
+       DO  in = 1, chem_emission_att%ncat
+!
+!--       Set surface fluxes only for either default, land or urban surface
+          IF ( .NOT. land_surface  .AND.  .NOT. urban_surface )  THEN
+             CALL set_gas_flux( surf_def_h(0), emission_index_chem, chem_emission_att%units,       &
+                                chem_emission%preproc_emission_data(:,:,:,in), time_factor(in) )
+          ELSE
+             CALL set_gas_flux( surf_usm_h, emission_index_chem, chem_emission_att%units,          &
+                                chem_emission%preproc_emission_data(:,:,:,in), time_factor(in) )
+             CALL set_gas_flux( surf_lsm_h, emission_index_chem, chem_emission_att%units,          &
+                                chem_emission%preproc_emission_data(:,:,:,in), time_factor(in) )
+          ENDIF
        ENDDO
-    ENDDO
-    
- END SUBROUTINE set_gas_flux 
-  
- 
+!
+!--    The next emission update is again after one hour
+       next_gas_emission_update = next_gas_emission_update + 3600.0_wp
+
+    ELSEIF ( lod_gas_emissions == 2 )  THEN
+!
+!--    Obtain time index for current input starting at 0.
+!--    @todo: At the moment emission data and simulated time correspond to each other.
+       chem_emission_att%i_hour = MINLOC( ABS( gas_emission_time - time_since_reference_point ),   &
+                                          DIM = 1 ) - 1
+!
+!--    Allocate the data input array always before reading in the data and deallocate after (NOTE 
+!--    that "preprocessed" input data array is applied now here)
+       ALLOCATE( chem_emission%default_emission_data(nys:nyn,nxl:nxr,1:nbins_aerosol) )
+!
+!--    Read in the next time step
+       CALL get_variable( id_chem, 'emission_values', chem_emission%default_emission_data,         &
+                          chem_emission_att%i_hour, 0, chem_emission_att%nspec-1, nxl, nxr, nys, nyn )
+!
+!--    Set surface fluxes only for either default, land or urban surface
+       IF ( .NOT. land_surface  .AND.  .NOT. urban_surface )  THEN
+          CALL set_gas_flux( surf_def_h(0), emission_index_chem, chem_emission_att%units,          &
+                             chem_emission%default_emission_data )
+       ELSE
+          CALL set_gas_flux( surf_usm_h, emission_index_chem, chem_emission_att%units,             &
+                             chem_emission%default_emission_data )
+          CALL set_gas_flux( surf_lsm_h, emission_index_chem, chem_emission_att%units,             &
+                             chem_emission%default_emission_data )
+       ENDIF
+!
+!--    Determine the next emission update
+       next_gas_emission_update = gas_emission_time(chem_emission_att%i_hour+2)
+
+       DEALLOCATE( chem_emission%default_emission_data )
+    ENDIF
+#else
+    message_string = 'salsa_emission_mode = "read_from_file", but preprocessor directive ' //   &
+                     ' __netcdf is not used in compiling!'
+    CALL message( 'salsa_gas_emission_setup', 'PA0643', 1, 2, 0, 6, 0 )
+
+#endif
+
+    CONTAINS
 !------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!> Sets the aerosol flux to aerosol arrays in 2a and 2b.
-!------------------------------------------------------------------------------!
- SUBROUTINE set_flux( surface, ncat_emission )
- 
-    USE arrays_3d,                                                             &
-        ONLY:  rho_air_zw
- 
-    USE surface_mod,                                                           &
-        ONLY:  surf_type
-    
-    IMPLICIT NONE
-
-    INTEGER(iwp) ::  ncat_emission  !< number of emission categories
-    TYPE(surf_type), INTENT(inout) :: surface  !< respective surface type
-    INTEGER(iwp) ::  b  !< loop index
-    INTEGER(iwp) ::  i   !< loop index
-    INTEGER(iwp) ::  j   !< loop index
-    INTEGER(iwp) ::  k   !< loop index
-    INTEGER(iwp) ::  m   !< running index for surface elements
-    INTEGER(iwp) ::  n   !< loop index for emission categories
-    INTEGER(iwp) ::  c   !< loop index
-    
-    DO  m = 1, surface%ns
-!
-!--    Get indices of respective grid point
-       i = surface%i(m)
-       j = surface%j(m)
-       k = surface%k(m)
-       
-       DO  n = 1, ncat_emission  
-          DO  b = 1, nbins
-             IF (  aerosol_number(b)%source(n,j,i) < 0.0_wp )  THEN
-                aerosol_number(b)%source(n,j,i) = 0.0_wp
-                CYCLE
+!> Set gas fluxes for selected type of surfaces
+!------------------------------------------------------------------------------!
+    SUBROUTINE set_gas_flux( surface, cc_i_mod, unit, source_array, time_fac )
+
+       USE arrays_3d,                                                                              &
+           ONLY: dzw, hyp, pt, rho_air_zw
+
+       USE grid_variables,                                                                         &
+           ONLY:  dx, dy
+
+       USE surface_mod,                                                                            &
+           ONLY:  surf_type
+
+       IMPLICIT NONE
+
+       CHARACTER(LEN=*), INTENT(in) ::  unit  !< flux unit in the input file
+
+       INTEGER(iwp) ::  ig  !< running index for gases
+       INTEGER(iwp) ::  i   !< loop index
+       INTEGER(iwp) ::  j   !< loop index
+       INTEGER(iwp) ::  k   !< loop index
+       INTEGER(iwp) ::  m   !< running index for surface elements
+
+       INTEGER(iwp), DIMENSION(:) ::  cc_i_mod   !< index of different gases in the input data
+
+       LOGICAL ::  use_time_fac  !< .TRUE. is time_fac present
+
+       REAL(wp), OPTIONAL ::  time_fac  !< emission time factor
+
+       REAL(wp), DIMENSION(ngases_salsa) ::  conv     !< unit conversion factor
+
+       REAL(wp), DIMENSION(nys:nyn,nxl:nxr,chem_emission_att%nspec), INTENT(in) ::  source_array  !<
+
+       TYPE(surf_type), INTENT(inout) :: surface  !< respective surface type
+
+       use_time_fac = PRESENT( time_fac )
+
+       DO  m = 1, surface%ns
+!
+!--       Get indices of respective grid point
+          i = surface%i(m)
+          j = surface%j(m)
+          k = surface%k(m)
+!
+!--       Unit conversion factor: convert to SI units (#/m2/s)
+          SELECT CASE ( TRIM( unit ) )
+             CASE ( 'kg/m2/yr' )
+                conv(1) = avo / ( amh2so4 * 3600.0_wp )
+                conv(2) = avo / ( amhno3 * 3600.0_wp )
+                conv(3) = avo / ( amnh3 * 3600.0_wp )
+                conv(4) = avo / ( amoc * 3600.0_wp )
+                conv(5) = avo / ( amoc * 3600.0_wp )
+             CASE ( 'g/m2/yr' )
+                conv(1) = avo / ( amh2so4 * 3.6E+6_wp )
+                conv(2) = avo / ( amhno3 * 3.6E+6_wp )
+                conv(3) = avo / ( amnh3 * 3.6E+6_wp )
+                conv(4) = avo / ( amoc * 3.6E+6_wp )
+                conv(5) = avo / ( amoc * 3.6E+6_wp )
+             CASE ( 'g/m2/s' )
+                conv(1) = avo / ( amh2so4 * 1000.0_wp )
+                conv(2) = avo / ( amhno3 * 1000.0_wp )
+                conv(3) = avo / ( amnh3 * 1000.0_wp )
+                conv(4) = avo / ( amoc * 1000.0_wp )
+                conv(5) = avo / ( amoc * 1000.0_wp )
+             CASE ( '#/m2/s' )
+                conv = 1.0_wp
+             CASE ( 'ppm/m2/s' )
+                conv = for_ppm_to_nconc * hyp(k) / pt(k,j,i) * ( 1.0E5_wp / hyp(k) )**0.286_wp *   &
+                       dx * dy * dzw(k)
+             CASE ( 'mumol/m2/s' )
+                conv = 1.0E-6_wp * avo
+             CASE DEFAULT
+                message_string = 'unknown unit for gas emissions: ' // TRIM( chem_emission_att%units )
+                CALL message( 'set_gas_flux','PA0644', 1, 2, 0, 6, 0 )
+
+          END SELECT
+
+          DO  ig = 1, ngases_salsa
+             IF ( use_time_fac )  THEN
+                surface%gtsws(m,ig) = surface%gtsws(m,ig) + rho_air_zw(k-1) * conv(ig) * time_fac  &
+                                      * MAX( 0.0_wp, source_array(j,i,cc_i_mod(ig) ) )
+             ELSE
+                surface%gtsws(m,ig) = surface%gtsws(m,ig) + rho_air_zw(k-1) * conv(ig)             &
+                                      * MAX( 0.0_wp, source_array(j,i,cc_i_mod(ig) ) )
              ENDIF
-!       
-!--          Set mass fluxes.  First bins include only SO4 and/or OC.      
-
-             IF ( b <= fn1a )  THEN
-!
-!--             Both sulphate and organic carbon
-                IF ( iso4 > 0  .AND.  ioc > 0 )  THEN
-                
-                   c = ( iso4 - 1 ) * nbins + b   
-                   surface%amsws(m,c) = surface%amsws(m,c) +                   &
-                                        emission_mass_fracs(n,1) /             &
-                                        ( emission_mass_fracs(n,1) +           &
-                                          emission_mass_fracs(n,2) ) *         &
-                                          aerosol_number(b)%source(n,j,i) *    &
-                                          api6 * aero(b)%dmid**3.0_wp *        &
-                                          arhoh2so4 * rho_air_zw(k-1)
-                   aerosol_mass(c)%source(n,j,i) =                             &
-                              aerosol_mass(c)%source(n,j,i) + surface%amsws(m,c)
-                   c = ( ioc - 1 ) * nbins + b   
-                   surface%amsws(m,c) = surface%amsws(m,c) +                   &
-                                        emission_mass_fracs(n,2) /             &
-                                        ( emission_mass_fracs(n,1) +           & 
-                                          emission_mass_fracs(n,2) ) *         &
-                                          aerosol_number(b)%source(n,j,i) *    &
-                                          api6 * aero(b)%dmid**3.0_wp * arhooc &
-                                          * rho_air_zw(k-1)
-                   aerosol_mass(c)%source(n,j,i) =                             &
-                              aerosol_mass(c)%source(n,j,i) + surface%amsws(m,c)
-!
-!--             Only sulphates
-                ELSEIF ( iso4 > 0  .AND.  ioc < 0 )  THEN
-                   c = ( iso4 - 1 ) * nbins + b   
-                   surface%amsws(m,c) = surface%amsws(m,c) +                   &
-                                        aerosol_number(b)%source(n,j,i) * api6 &
-                                        * aero(b)%dmid**3.0_wp * arhoh2so4     &
-                                        * rho_air_zw(k-1)
-                   aerosol_mass(c)%source(n,j,i) =                             &
-                              aerosol_mass(c)%source(n,j,i) + surface%amsws(m,c)
-!             
-!--             Only organic carbon             
-                ELSEIF ( iso4 < 0  .AND.  ioc > 0 )  THEN
-                   c = ( ioc - 1 ) * nbins + b   
-                   surface%amsws(m,c) = surface%amsws(m,c) +                   &
-                                        aerosol_number(b)%source(n,j,i) * api6 &
-                                        * aero(b)%dmid**3.0_wp * arhooc        &
-                                        * rho_air_zw(k-1)
-                   aerosol_mass(c)%source(n,j,i) =                             &
-                              aerosol_mass(c)%source(n,j,i) + surface%amsws(m,c)
-                ENDIF
-                
-             ELSEIF ( b > fn1a )  THEN
-!
-!--             Sulphate
-                IF ( iso4 > 0 )  THEN
-                   CALL set_mass_flux( surface, m, b, iso4, n,                 &
-                                       emission_mass_fracs(n,1), arhoh2so4,    &
-                                       aerosol_number(b)%source(n,j,i) )
-                ENDIF 
-!             
-!--             Organic carbon                 
-                IF ( ioc > 0 )  THEN          
-                  CALL set_mass_flux( surface, m, b, ioc, n,                   &
-                                      emission_mass_fracs(n,2), arhooc,        &
-                                      aerosol_number(b)%source(n,j,i) )
-                ENDIF
-!
-!--             Black carbon
-                IF ( ibc > 0 )  THEN
-                   CALL set_mass_flux( surface, m, b, ibc, n,                  &
-                                       emission_mass_fracs(n,3), arhobc,       &
-                                       aerosol_number(b)%source(n,j,i) )
-                ENDIF
-!
-!--             Dust
-                IF ( idu > 0 )  THEN
-                   CALL set_mass_flux( surface, m, b, idu, n,                  &
-                                       emission_mass_fracs(n,4), arhodu,       &
-                                       aerosol_number(b)%source(n,j,i) )
-                ENDIF
-!
-!--             Sea salt
-                IF ( iss > 0 )  THEN
-                   CALL set_mass_flux( surface, m, b, iss, n,                  &
-                                       emission_mass_fracs(n,5), arhoss,       &
-                                       aerosol_number(b)%source(n,j,i) )
-                ENDIF
-!
-!--             Nitric acid
-                IF ( ino > 0 )  THEN
-                   CALL set_mass_flux( surface, m, b, ino, n,                  &
-                                       emission_mass_fracs(n,6), arhohno3,     &
-                                       aerosol_number(b)%source(n,j,i) )
-                ENDIF
-!
-!--             Ammonia
-                IF ( inh > 0 )  THEN
-                   CALL set_mass_flux( surface, m, b, inh, n,                  &
-                                       emission_mass_fracs(n,7), arhonh3,      &
-                                       aerosol_number(b)%source(n,j,i) )
-                ENDIF
-                
-             ENDIF
-!             
-!--          Save number fluxes in the end 
-             surface%answs(m,b) = surface%answs(m,b) +                         &
-                               aerosol_number(b)%source(n,j,i) * rho_air_zw(k-1)
-             aerosol_number(b)%source(n,j,i) = surface%answs(m,b)
-          ENDDO
-       
-       ENDDO
-       
-    ENDDO
-    
- END SUBROUTINE set_flux 
- 
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Sets the mass emissions to aerosol arrays in 2a and 2b.
-!------------------------------------------------------------------------------!
- SUBROUTINE set_mass_flux( surface, surf_num, b, ispec, n, mass_frac, prho,    &
-                           nsource )
-                           
-    USE arrays_3d,                                                             &
-        ONLY:  rho_air_zw
-
-    USE surface_mod,                                                           &
-        ONLY:  surf_type
-    
-    IMPLICIT NONE
-
-    INTEGER(iwp), INTENT(in) :: b         !< Aerosol size bin index
-    INTEGER(iwp), INTENT(in) :: ispec     !< Aerosol species index
-    INTEGER(iwp), INTENT(in) :: n         !< emission category number    
-    INTEGER(iwp), INTENT(in) :: surf_num  !< index surface elements
-    REAL(wp), INTENT(in) ::  mass_frac    !< mass fraction of a chemical 
-                                          !< compound in all bins 
-    REAL(wp), INTENT(in) ::  nsource      !< number source (#/m2/s)
-    REAL(wp), INTENT(in) ::  prho         !< Aerosol density
-    TYPE(surf_type), INTENT(inout) ::  surface  !< respective surface type
-     
-    INTEGER(iwp) ::  i  !< loop index 
-    INTEGER(iwp) ::  j  !< loop index
-    INTEGER(iwp) ::  k  !< loop index
-    INTEGER(iwp) ::  c  !< loop index
-    
-!
-!-- Get indices of respective grid point
-    i = surface%i(surf_num)
-    j = surface%j(surf_num)
-    k = surface%k(surf_num)
-!          
-!-- Subrange 2a:
-    c = ( ispec - 1 ) * nbins + b
-    surface%amsws(surf_num,c) = surface%amsws(surf_num,c) + mass_frac * nsource&
-                                * aero(b)%core * prho * rho_air_zw(k-1)
-    aerosol_mass(c)%source(n,j,i) = aerosol_mass(c)%source(n,j,i) +            &
-                                    surface%amsws(surf_num,c)
-!          
-!-- Subrange 2b:
-    IF ( .NOT. no_insoluble )  THEN
-       WRITE(*,*) 'All emissions are soluble!'
-    ENDIF
-    
- END SUBROUTINE set_mass_flux
- 
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Sets the mass sources to aerosol arrays in 2a and 2b.
-!------------------------------------------------------------------------------!
- SUBROUTINE set_mass_source( k, j, i,  ispec, mass_frac, prho, nsource, fillval )
-
-    USE surface_mod,                                                           &
-        ONLY:  surf_type
-    
-    IMPLICIT NONE
-    
-    INTEGER(iwp), INTENT(in) :: ispec     !< Aerosol species index
-    REAL(wp), INTENT(in) ::  fillval      !< _FillValue in the NetCDF file
-    REAL(wp), INTENT(in) ::  mass_frac    !< mass fraction of a chemical 
-                                          !< compound in all bins  
-    REAL(wp), INTENT(in), DIMENSION(:) ::  nsource  !< number source
-    REAL(wp), INTENT(in) ::  prho         !< Aerosol density
-    
-    INTEGER(iwp) ::  b !< loop index    
-    INTEGER(iwp) ::  ee !< index: end 
-    INTEGER(iwp) ::  i  !< loop index 
-    INTEGER(iwp) ::  j  !< loop index
-    INTEGER(iwp) ::  k  !< loop index
-    INTEGER(iwp) ::  c  !< loop index
-    INTEGER(iwp) ::  ss !<index: start 
-!          
-!-- Subrange 2a:
-    ss = ( ispec - 1 ) * nbins + in2a
-    ee = ( ispec - 1 ) * nbins + fn2a
-    b = in2a
-    DO c = ss, ee
-       IF ( nsource(b) /= fillval )  THEN
-          aerosol_mass(c)%source(k,j,i) = aerosol_mass(c)%source(k,j,i) +      &
-                                       mass_frac * nsource(b) * aero(b)%core * &
-                                       prho 
-       ENDIF
-       b = b+1
-    ENDDO
-!          
-!-- Subrange 2b:
-    IF ( .NOT. no_insoluble )  THEN
-       WRITE(*,*) 'All sources are soluble!'
-    ENDIF
-    
- END SUBROUTINE set_mass_source 
- 
+          ENDDO  ! ig
+
+       ENDDO  ! m
+
+    END SUBROUTINE set_gas_flux
+
+ END SUBROUTINE salsa_gas_emission_setup
+
 !------------------------------------------------------------------------------!
 ! Description:
